package org.brains2b.coffee.file;

import org.brains2b.coffee.message.Article;
import org.brains2b.coffee.message.ArticleBody;
import org.brains2b.coffee.message.ArticleHeader;
import org.brains2b.coffee.message.NNTPMessage;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class ArticleHandler extends FileContentHandler {

	private String m_lastKey;
	private Article m_article;
	
	public NNTPMessage getMessage() {
		return m_article;
	}

	public void characters(char[] ch, int start, int length)
			throws SAXException {
		String s = new String(ch,start,length);
		if (!m_lastKey.equals("body")) {
			m_article.getHeader().addHeaderValue(m_lastKey, s);
		} else {
			m_article.getBody().addLine(s);
		}

	}

	public void endDocument() throws SAXException {
		
	}

	public void endElement(String uri, String localName, String qName)
			throws SAXException {
		m_lastKey=null;

	}

	public void startDocument() throws SAXException {
		
	}

	public void startElement(String uri, String localName, String qName,
			Attributes atts) throws SAXException {
		m_lastKey= qName;
		if ("article".equals(qName)) {
			m_article = new Article();
		} else if ("header".equals(qName)) {
			m_article.setHeader(new ArticleHeader());
		} else if ("body".equals(qName)) {
			m_article.setBody(new ArticleBody());
		}
	}

}
