/* 	ServerHandler.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 12-aug-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.file;

import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.message.local.CoffeeBean;
import org.brains2b.coffee.message.local.CoffeeMenu;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

public class CoffeeMenuHandler extends FileContentHandler {

    private CoffeeMenu m_list;
    private CoffeeBean m_last;
    private String m_qName;
    private Attributes m_atts;
    public void setMessageName(String name) {

    }

    public NNTPMessage getMessage() {
       return m_list;
    }

    public void endDocument() throws SAXException {
        
    }

    public void startDocument() throws SAXException {
        
    }

    public void characters(char[] ch, int start, int length)
            throws SAXException {
       m_last.setContent(m_qName,m_atts,new String(ch,start,length));

    }

    public void endElement(String namespaceURI, String localName, String qName)
            throws SAXException {
        if (qName.equals(m_qName)) {
            m_qName=null;
        } 
    }

    public void startElement(String namespaceURI, String localName,
            String qName, Attributes atts) throws SAXException {
       if (qName.equals(m_list.getId())) {
          m_last = m_list.createBean();
          m_last.setAttributes(atts); 
       } else {
           m_qName=qName;
           m_atts =atts;
       }

    }

    public CoffeeMenu getList() {
        return m_list;
    }

    public void setList(CoffeeMenu list) {
        m_list = list;
    }
}
