/* 	CfStatusBar.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 26-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.EmptyBorder;

import org.brains2b.coffee.Ticket;
import org.brains2b.coffee.TicketBroker;
import org.brains2b.coffee.message.InfoMessage;
import org.brains2b.swingext.dialog.DialogHelper;
import org.brains2b.task.TaskEvent;
import org.brains2b.task.TaskListener;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class CfStatusBar extends JPanel implements TaskListener,ActionListener {
    
    private JProgressBar m_progressBar;
    private JLabel m_status;
	private JButton m_queue;
	private Ticket m_lastTicket;
    /**
     * 
     */
    public CfStatusBar() {
		init();
    }
    
    private void init() {
        
		setBorder(new EmptyBorder(2,0,1,0));
		
		m_status=new JLabel();
		m_progressBar=new JProgressBar();
        m_progressBar.setPreferredSize(new Dimension(240,22));
        m_queue = new JButton("0 / 0");
        m_queue.addActionListener(this);
        add(m_queue);
		add(m_progressBar);
		
    }
    public void taskProgressed(TaskEvent e) {
		if (e.getSource() instanceof TicketBroker) {
			m_queue.setText(e.getPosition() + " / " + e.getMax());
		} else if (e.getSource() instanceof Ticket) {
			if (e.isFinished()) {
				Ticket t = (Ticket) e.getSource();
            	if (t.getMessage()!=null && t.getMessage().getType()<0) {
            		displayMessage((InfoMessage) ((Ticket) e.getSource()).getMessage());
            	}
            	if (m_lastTicket!=null && t == m_lastTicket) {
					m_progressBar.setValue(0);
            		m_progressBar.setIndeterminate(false);
				}
            	m_lastTicket=null;
            	return;
			} else if (m_lastTicket!=null && m_lastTicket!=e.getSource()) {
				return;
			}
			m_lastTicket = (Ticket) e.getSource();
			if (e.getMax()!=m_progressBar.getMaximum()) {
            	m_progressBar.setMaximum(e.getMax());
            	m_progressBar.setMinimum(e.getMin());
            }
            if (e.getMax()==e.getPosition()) {
                m_progressBar.setIndeterminate(true);
            } else {
                m_progressBar.setIndeterminate(false);
            }
            m_progressBar.setValue(e.getPosition());
		}
		
		
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==m_queue) {
			CfQueView queView = new CfQueView();
			queView.setQueue(TicketBroker.getBroker().getQueList());
			TicketBroker.getBroker().addTaskListener(queView);
			DialogHelper.showDialog(getParent(), queView, "Queue");
		}
	}
    
	private void displayMessage(InfoMessage message) {
		m_status.setText(message.getResponse());
	}
    
}
