/**
 * 
 */
package org.brains2b.coffee.gui.list;

import java.util.ArrayList;
import java.util.List;

import javax.swing.AbstractListModel;

public class MutableListModel extends AbstractListModel {

    ArrayList m_data;
    
    public MutableListModel() {
        super();
    }
    
    public Object getElementAt(int index) {
        if (m_data==null) {
            return null;
        }
        return m_data.get(index);
    }

    public int getSize() {
        return m_data==null?0:m_data.size();
    }
    
    public void setData(List l) {
    	if (l==null) {
    		if (m_data!=null) m_data.clear();
    		return;
    	}
        m_data=new ArrayList();
        m_data.addAll(l);
        fireContentsChanged(this, 0, m_data.size());
    }
    
    public void addData(Object data) {
       if (m_data==null) {
        m_data = new ArrayList();
    }
       m_data.add(data);
       fireIntervalAdded(this, m_data.size()-1, m_data.size());
    }
    
    public Object[] getData() {
        if (m_data==null) {
            return null;
        }
        Object[] result= new Object[m_data.size()];
        m_data.toArray(result);
        return result;
    }
    
    public void removeData(int index) {
        if (index>=0 && m_data!=null && index<m_data.size()) {
            m_data.remove(index);
            fireIntervalRemoved(this,index, index);
        }
    }
}