/* 	InfoMessage.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 16-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.message;

import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class InfoMessage implements NNTPMessage {
	private boolean m_headerSet;
    
	protected int m_type;
	protected String m_response;
	protected StringBuffer m_body;
	/**
     * 
     */
    public InfoMessage() {
        super();
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#addLine(java.lang.String)
     */
    public void addLine(String s) {
        if (isHeaderSet()) {
           if (m_body==null) {
            m_body=new StringBuffer();
        }
           m_body.append(s);
        }

    }

    public void addHeader(int id,String s) {
        m_headerSet=true;
        m_type=id;
        m_response=s;
        
    }
    public boolean isHeaderSet() {
        return m_headerSet;
    }
    public String getBody() {
        if (m_body==null) {
            return "";
        } else {
        	return m_body.toString();
        }
    }
    public int getType() {
        return m_type;
    }
    public String getResponse() {
        return m_response;
    }
    public String getId() {
        return m_response;
    }
    
    public String toString() {
        StringBuffer sb=new StringBuffer();
        sb.append(m_type).append(" ").append(m_response);
        sb.append(getBody());
        return sb.toString();
    }
    
    public void endMessage() {
        
    }
    
    public void writeMessage(SAXWriter sw) throws SAXException {
        
    }
    
    public boolean hasContent() {
        return m_type<200;
    }
    
    public int getSize() {
        return 1;
    }
}
