package test.org.brains2b.coffee.decode;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;

import junit.framework.TestCase;

import org.brains2b.coffee.decode.UUDecoder;
import org.brains2b.coffee.message.local.FileMessage;

public class UUDecoderTest extends TestCase {

	public void testEncode() {
		try {
			UUDecoder uuen = new UUDecoder();
			String s = uuen.encode(new File("test/1280.jpg"),1,300*1024);
        	BufferedWriter bw =new BufferedWriter(new FileWriter(File.createTempFile("uuentest", ".tmp")));
        	bw.write(s);
        	bw.close();
		} catch (Exception ex) {
			assertTrue(ex.getMessage(),false);
		}
	}
	
	public void testEncodePart() {
		try {
			File tf = new File("test/1280.jpg");
			UUDecoder uuen = new UUDecoder();
			String s1 = uuen.encode(tf,1,100*1024);
			String s2 = uuen.encode(tf,2,100*1024);
        	uuen.decodePiece(s1);
        	uuen.decodePiece(s2);
        	FileMessage fm = uuen.getFileMessage();
			compareBytes(tf,fm.getData());
		} catch (Exception ex) {
			ex.printStackTrace();
			assertTrue(ex.getMessage(),false);
		}
	}

	private void compareBytes(File f, byte[] b) {
		assertEquals(f.length(),b.length); 
		try {
			FileInputStream fis = new FileInputStream(f);
			byte[] br = new byte[4096];
			int cnt =0;
			int len = -1;
			while ((len=fis.read(br))!=-1) {
				for (int i=0;i<len;i++) {
					assertEquals(br[i],b[i+cnt*4096]);
				}
				cnt++;
			}
			fis.close();
		} catch (IOException iex) {
			assertTrue(iex.getMessage(),false);
		}
	}
}
