/* 	NewsGroupTest.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 17-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.message;

import java.io.StringWriter;
import java.util.Date;

import junit.framework.TestCase;

import org.brains2b.coffee.message.NewsGroup;
import org.brains2b.saxo.SAXWriter;
import org.brains2b.util.DateHelper;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class NewsGroupTest extends TestCase {

    public static void main(String[] args) {
        junit.swingui.TestRunner.run(NewsGroupTest.class);
    }
    
    public void testAddLine() {
        NewsGroup group=new NewsGroup();
        group.addLine("alt.test.coffeebreak 10000 5 n");
        assertEquals("alt.test.coffeebreak",group.getName());
        assertEquals(5,group.getFirst());
        assertEquals(10000,group.getLast());
        assertTrue(!group.isAllowPost());
        
    }
    
    public void testAddHeader() {
        NewsGroup group=new NewsGroup();
        group.addHeader(211,"9 5 10001 alt.test.coffeebreak");
        assertEquals("alt.test.coffeebreak",group.getName());
        assertEquals(5,group.getFirst());
        assertEquals(10001,group.getLast());
        assertEquals(9,group.getEstimate());
        assertTrue(!group.isAllowPost());
        
    }
    
    public void testWriteClass() {
        NewsGroup group=new NewsGroup();
        group.addLine("alt.test.coffeebreak 10000 5 n");
        StringWriter stw=new StringWriter();
        SAXWriter sw=new SAXWriter(stw);
        try {
        	group.writeMessage(sw);
        	assertEquals("\n<newsgroup name=\"alt.test.coffeebreak\" first=\"5\" last=\"10000\" allowPost=\"false\" lastUpdated=\"" + DateHelper.fromDate(new Date()) + "\">\n</newsgroup>"
        		, stw.toString());
        } catch (Exception ex) {
            assertTrue(ex.getMessage(),false);
        }
        
    }

}
