/* 	PostArticleTest.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 14-jan-2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.message;

import java.util.Date;

import junit.framework.TestCase;

import org.brains2b.coffee.message.Article;
import org.brains2b.coffee.message.ArticleBody;
import org.brains2b.coffee.message.ArticleHeader;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.message.PostArticle;
import org.brains2b.coffee.nntp.NNTPConnector;
import org.brains2b.coffee.util.CfDateHelper;
import org.brains2b.log.Logger;

public class PostArticleTest extends TestCase {

    public PostArticleTest(String name) {
        super(name);
    }

    public void testPost() {
        Article a =new Article();
        a.setNewsGroup("alt.test");
        
        ArticleHeader ah = new ArticleHeader();
        ah.setSubject("RE: Test CoffeeBreak");
        ah.addHeaderValue("From", "dennis@nonosmap.org");
        ah.addHeaderValue("Date", CfDateHelper.format(new Date()));
        
        ArticleBody ab = new ArticleBody();
        ab.addLine("Test posting from CoffeeBreak\n");
        ab.addLine("Please ignore.\n");
        
        a.setHeader(ah);
        a.setBody(ab);
        
        String s = PostArticle.create(a);
        Logger.println(s);
        assertNotNull(s);
        
        NNTPConnector con = new NNTPConnector("news.xs4all.nl",119);
        try {
            con.connect();
            NNTPMessage msg= con.post(s);
            Logger.println(msg.toString());
            con.close();
            assertEquals(240,msg.getType());
        } catch (Exception ex) {
            Logger.printException(ex);
        }
    }
}
