/* 	YencTest.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 17-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.util;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

import junit.framework.TestCase;

import org.brains2b.coffee.util.Yenc;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class YencTest extends TestCase {
    
    public static void main(String[] args) {
        junit.swingui.TestRunner.run(YencTest.class);
    }

    public void testDecode() {
        try {
        	String s=readContent("test/test.body");
        	Yenc yenc=new Yenc();
        	yenc.decodePiece(s);
        	File f=yenc.decode();
        } catch (Exception ex) {
            ex.printStackTrace();
            assertTrue(ex.getMessage(),false);
        }
    }
    
    public void testMultiDecode() {
        try {
        	Yenc yenc=new Yenc();
        	String s=readContent("test/multi1.body");
        	yenc.decodePiece(s);
        	s=readContent("test/multi2.body");
        	yenc.decodePiece(s);
        	File f=yenc.decode();
        } catch (Exception ex) {
            ex.printStackTrace();
            assertTrue(ex.getMessage(),false);
        }
    }
    
    public void testEncode() {
        try {
        	Yenc yenc=new Yenc();
        	String s = yenc.encode(new File("test/1280.jpg"),1,300*1024);
        	BufferedWriter bw =new BufferedWriter(new FileWriter(File.createTempFile("yenctest", ".tmp")));
        	bw.write(s);
        	bw.close();
        	//The proof is in the pudding
        	File tmp2 = new File(System.getProperty("java.io.tmpdir"));
        	yenc.decodePiece(s);
        	yenc.decode(tmp2);
        } catch (Exception ex) {
            ex.printStackTrace();
            assertTrue(ex.getMessage(),false);
        }
    }

    private String readContent(String file) throws Exception {
        InputStreamReader fr=new InputStreamReader(new FileInputStream(file),"ISO-8859-1");
        
    	int c=0;
    	int i=0;
    	StringBuffer sb=new StringBuffer();
    	while ((c=fr.read())!=-1) {
    	    i++;
    	    if (i==195) {
    	        System.out.println("break");
    	    }
    	    sb.append((char) c);
    	}
    	fr.close();
    	
    	return new String(sb.toString());
    }
}
